## icewm 2.8.0

=== debian/changelog ===
icewm (2.8.0-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Sat, 09 Oct 2021 14:59:00 +0200

icewm (2.7.0-1) unstable; urgency=low

  * New upstream release (closes: #991153)

 -- Eduard Bloch <blade@debian.org>  Thu, 19 Aug 2021 19:16:50 +0200

icewm (2.6.0-1) experimental; urgency=low

  * New upstream release
  * Appending the old upstream changelog to the current ChangeLog.gz contents
    and removing confusing legacy changelog file from docs

 -- Eduard Bloch <blade@debian.org>  Sat, 10 Jul 2021 19:13:00 +0200

icewm (2.5.0-1) experimental; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Tue, 29 Jun 2021 12:47:10 +0200

icewm (2.4.0+git20210619-1) experimental; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Sun, 20 Jun 2021 13:19:13 +0200

icewm (2.3.4-1) experimental; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Tue, 11 May 2021 10:53:42 +0200

icewm (2.3.2-1) experimental; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Thu, 15 Apr 2021 13:20:21 +0200

icewm (2.3.1-1) experimental; urgency=low

  * New upstream release
  * Adding explicit dependency on sensible-utils

 -- Eduard Bloch <blade@debian.org>  Sun, 04 Apr 2021 12:47:13 +0200

icewm (2.2.1-1) experimental; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Sun, 28 Feb 2021 22:44:13 +0100

=== debian/control ===
Source: icewm
Section: x11
Priority: optional
Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: debhelper (>= 9), libxrender-dev, gettext, libxft-dev (>> 2.1.1) | libxft2-dev, libsndfile1-dev, libao-dev, libsm-dev, libx11-dev, libxext-dev, libxinerama-dev, libxrandr-dev, x11proto-core-dev | x-dev, dpkg-dev (>= 1.16.1~), cmake, asciidoctor, libglib2.0-dev, libfribidi-dev, librsvg2-dev, libxcomposite-dev, libxdamage-dev, pandoc, libimlib2-dev
Build-Conflicts: libttf-dev, libesd0-dev
Standards-Version: 4.5.0
Vcs-Git: https://github.com/Code7R/icewm.git

Package: icewm-common
Architecture: any
Conflicts: menu (<< 2.1.9-1)
Replaces: icewm (<< 1.2.14), icewm-gnome-support (<< 1.3.8-3), icewm-themes (<< 1.3.8-3)
Depends: ${misc:Depends}, ${shlibs:Depends}, sensible-utils
Recommends: menu, xscreensaver, xterm
Description: wonderful Win95-OS/2-Motif-like window manager
 IceWm is a Window Manager for X Window System. Can emulate the look of
 Windows'95, OS/2 Warp 3,4, Motif. Tries to take the best features of the above
 systems.
 Features multiple workspaces, opaque move/resize, task bar, window list,
 mailbox status, digital clock. Fast and small.
 .
 This package provides the common files for icewm, icewm-experimental and
 icewm-lite binary packages.

Package: icewm
Architecture: any
Depends: icewm-common (= ${binary:Version}), ${shlibs:Depends}, fonts-dejavu-core | ttf-dejavu-core | custom-icewm-font, sensible-utils, ${misc:Depends}
Conflicts: icewm-common (<< 1.3.8-3)
Provides: x-window-manager
Description: wonderful Win95-OS/2-Motif-like window manager
 IceWm is a Window Manager for X Window System. It is fast and
 memory-efficient, and it provides many different looks including Windows'95,
 OS/2 Warp 3,4, Motif. It tries to take the best features of the above
 systems. Additional features include  multiple workspaces, opaque move/resize,
 task bar, window list, mailbox status, digital clock.

Package: icewm-lite
Architecture: any
Depends: icewm (= ${binary:Version}), icewm-common (= ${binary:Version}), ${misc:Depends}
Section: oldlibs
Description: transitional package for icewm
 IceWm is a Window Manager for X Window System. It is fast and
 memory-efficient, and it provides different looks and some desktop-like
 functionality.
 .
 This package only exists to maintain compatibility to system setups that
 relied on the former icewm-lite package. It can be safely removed once the
 system dependencies has been adjusted.

Package: icewm-experimental
Architecture: any
Depends: icewm (= ${binary:Version}), icewm-common (= ${binary:Version}), ${misc:Depends}
Provides: x-window-manager
Description: wonderful Win95-OS/2-Motif-like window manager
 IceWm is a Window Manager for X Window System. It is fast and
 memory-efficient, and it provides many different looks including Windows'95,
 OS/2 Warp 3,4, Motif. It tries to take the best features of the above
 systems. Additional features include  multiple workspaces, opaque move/resize,
 task bar, window list, mailbox status, digital clock.
 .
 This package sometimes provides special IceWm versions with experimental
 features enabled. When the configurations of the packages do not diverge
 it simply enforces an upgrade to the current icewm package.

## icewm 2.9.0

=== debian/changelog ===
icewm (2.9.0-1.0antix1) unstable; urgency=medium

  * latest 2.9.0 uptream release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Wed, 24 Nov 2021 13:56:59 +0200

icewm (2.8.0-1.0antix1) unstable; urgency=medium

  * latest 2.8.0 uptream release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Tue, 05 Oct 2021 23:17:01 +0300

## icewm 2.9.1

=== debian/changelog ===
icewm (2.9.1-1.0antix1) unstable; urgency=medium

  * latest 2.9.1 uptream release
  * antiX build 

 -- anticapitalista <antix@operamail.com>  Thu, 02 Dec 2021 21:31:19 +0200

## icewm 2.9.2

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

PROJECT(ICEWM CXX)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED on)
# TODO: drop this warning around xmas 2020 and raise cmake_minimum_required instead; Debian Jessie EOLs around 2020-06
if(${CMAKE_VERSION} VERSION_LESS "3.1")
    message(WARNING "!! Ancient cmake version detected, please pass flags for C++11 enabling manually through CXXFLAGS environment variable or override CMAKE_CXX_FLAGS")
endif()

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckLibraryExists)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckIncludeFile)
INCLUDE(CheckTypeSize)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(FindPkgConfig)
INCLUDE(CheckCXXSourceCompiles)
INCLUDE(CheckCXXCompilerFlag)

SET(CXXFLAGS_COMMON -pthread -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE -DHAVE_CONFIG_H -include "${CMAKE_BINARY_DIR}/config.h")
include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

set(icewm_libs "")
# optimize for release if not defined explicitly, can be overriden with CMAKE_BUILD_TYPE "None"
if("${CMAKE_BUILD_TYPE}" STREQUAL "" AND ("" STREQUAL "${CMAKE_CXX_FLAGS}"))
    SET(CMAKE_BUILD_TYPE Release)
endif()

# I don't need -rdynamic, thanks!
SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")

SET(CMAKE_REQUIRED_FLAGS )

CHECK_CXX_COMPILER_FLAG(-fvisibility=hidden CXX_VHI)
if(CXX_VHI)
    list(APPEND CXXFLAGS_COMMON -fvisibility=hidden)
endif()

CHECK_CXX_COMPILER_FLAG(-fvisibility-inlines-hidden CXX_VIHI)
if(CXX_VIHI)
    list(APPEND CXXFLAGS_COMMON -fvisibility-inlines-hidden)
endif()

# teach GCC7+ to interpret our comments
CHECK_CXX_COMPILER_FLAG(-Wimplicit-fallthrough=2 HAS_FALLTHROUGH_OPTION)
if(HAS_FALLTHROUGH_OPTION)
    list(APPEND CXXFLAGS_COMMON -Wimplicit-fallthrough=2)
else()
    CHECK_CXX_COMPILER_FLAG(-Wimplicit-fallthrough HAS_FALLTHROUGH_OPTION)
    if(HAS_FALLTHROUGH_OPTION)
        list(APPEND CXXFLAGS_COMMON -Wimplicit-fallthrough)
    endif()
endif()

#CHECK_CXX_COMPILER_FLAG(-Wl,-fuse-ld=gold CXX_LINKER_GOLD)
#if(CXX_LINKER_GOLD)
#    list(APPEND icewm_libs -Wl,-fuse-ld=gold)
#endif()

option(CONFIG_IMLIB2 "Imlib2 image loader" on)
option(CONFIG_LIBPNG "PNGLIB image loader" off)
option(CONFIG_LIBJPEG "JPEGLIB image loader" off)
option(CONFIG_GDK_PIXBUF_XLIB "GDK-PIXBUF image loader" off)
option(CONFIG_LIBRSVG "Support SVG format icons" off)
option(CONFIG_XPM "XPM image loader" on)
option(CONFIG_I18N "Define to enable internationalization" on)
option(CONFIG_XRANDR "Define to enable XRANDR extension" on)
option(CONFIG_SESSION "Define to enable X session management" on)
option(CONFIG_EXTERNAL_TRAY "Define for external systray (deprecated)" off)
option(ENABLE_NLS "Enable Native Language Support" on)
option(ENABLE_LTO "Enable Link Time Optimization" off)
option(ENABLE_LOGEVENTS "Enable logging of X11 events" off)

set(LOGEVENTS ${ENABLE_LOGEVENTS})
SET(CONFIG_DEFAULT_THEME "default/default.theme" CACHE STRING "Name of default theme")
SET(CONFIG_DEFAULT_BACKGROUND "" CACHE STRING "Default background image or directory")
SET(CONFIG_UNICODE_SET "" CACHE STRING "Your iconv unicode set in machine endian encoding (e.g. WCHAR_T, UCS-4-INTERNAL, UCS-4LE, UCS-4BE)")
# turn off when empty, see config.h template for details
IF("" STREQUAL "${CONFIG_UNICODE_SET}")
    SET(CONFIG_UNICODE_SET OFF)
ELSE()
    MESSAGE(STATUS "Configured custom unicode set: ${CONFIG_UNICODE_SET}.")
ENDIF()
SET(XTERMCMD xterm CACHE STRING "Default terminal emulator for X11")

# TODO: find some common helper to handle that variables
if(ENABLE_NLS OR CONFIG_I18N)
    find_library(CONFIG_LIBICONV iconv)
    if(CONFIG_LIBICONV)
        LIST(APPEND nls_LIBS iconv)
    endif()
    INCLUDE(FindIntl)
    if(Intl_FOUND)
        LIST(APPEND nls_LIBS ${Intl_LIBRARIES})
        if(${Intl_INCLUDE_DIRS})
            LIST(APPEND nls_CFLAGS -I${Intl_INCLUDE_DIRS})
        endif()
    endif()
endif()

if(ENABLE_LTO AND ${CMAKE_HOST_SYSTEM_NAME} MATCHES "Linux")
    list(APPEND CXXFLAGS_COMMON -flto)
    list(APPEND EXTRA_LIBS -flto)
endif()

# the only used ones...
# for x in `cat funclist` ; do grep $x src/* lib/* && echo $x >> exlist ; done
# perl -e 'print "CHECK_FUNCTION_EXISTS($_ HAVE_".uc($_).")\n" for @ARGV' `cat exlist`
# perl -e 'print "#cmakedefine HAVE_".uc($_)."\n" for @ARGV' `cat exlist`
CHECK_FUNCTION_EXISTS(backtrace_symbols_fd HAVE_BACKTRACE_SYMBOLS_FD)
CHECK_FUNCTION_EXISTS(memrchr HAVE_MEMRCHR)
CHECK_FUNCTION_EXISTS(strlcat HAVE_STRLCAT)
CHECK_FUNCTION_EXISTS(strlcpy HAVE_STRLCPY)
CHECK_FUNCTION_EXISTS(sysctl HAVE_SYSCTL)
CHECK_FUNCTION_EXISTS(sysctlbyname HAVE_SYSCTLBYNAME)

# perl -e 'do { s/\.|\//_/g; $_=uc $_;  print "#cmakedefine HAVE_$_\n"} for @ARGV' `cat headersDa`
# perl -e 'do {my $orig=$_; s/\.|\//_/g; $_=uc $_; print "CHECK_INCLUDE_FILE_CXX($orig HAVE_$_)\n"} for @ARGV' `cat headersDa`
CHECK_INCLUDE_FILE_CXX(execinfo.h HAVE_EXECINFO_H)
CHECK_INCLUDE_FILE_CXX(sched.h HAVE_SCHED_H)
CHECK_INCLUDE_FILE_CXX(sys/sched.h HAVE_SYS_SCHED_H "-include /usr/include/sched.h")
CHECK_INCLUDE_FILE_CXX(sys/sysctl.h HAVE_SYS_SYSCTL_H "-include /usr/include/sys/types.h")
CHECK_INCLUDE_FILE_CXX(uvm/uvm_param.h HAVE_UVM_UVM_PARAM_H)

#########################################################
# fiting flags to options and available system features #
#########################################################

pkg_check_modules(fontconfig fontconfig)
pkg_check_modules(xrender REQUIRED xrender)
pkg_check_modules(xcomposite REQUIRED xcomposite)
pkg_check_modules(xdamage REQUIRED xdamage)
pkg_check_modules(xfixes REQUIRED xfixes)
pkg_check_modules(xext REQUIRED xext)
pkg_check_modules(x11 REQUIRED x11)

CHECK_LIBRARY_EXISTS(X11 XInternAtoms ${x11_LIBDIR} HAVE_XINTERNATOMS)

set(icewm_img_libs ${xrender_LDFLAGS} ${xcomposite_LDFLAGS} ${xdamage_LDFLAGS} ${xfixes_LDFLAGS})

# It would be a good idea to use different names for the image options and do the
# logics here.  For now, this self-adapting code modifies the option variables.

set(HINT_CURSORS
[=[
 Cursor support requires either -DCONFIG_XPM=on or -DCONFIG_IMLIB2=on.
]=])

set(HINT_IMG_LOADERS
[=[
 There is a choice to be made between two image loaders.
 Either 'yimage_gdk' must be enabled by -DCONFIG_GDK_PIXBUF_XLIB=on,
 or 'imlib2' must be enabled by -DCONFIG_IMLIB2=on,
 or else 'yximage' must be enabled by -DCONFIG_LIBPNG=on.
 The latter requires -DCONFIG_XPM=on, while -DCONFIG_LIBJPEG=on is recommended.
 Support SVG format for Imlib2 or GdkPixbuf with -DCONFIG_LIBRSVG=on.
 ]=] ${HINT_CURSORS})

# image configuration error check
if(CONFIG_IMLIB2)
    #ok
    if (NOT CONFIG_LIBRSVG)
        message(WARNING "CONFIG_LIBRSVG is recommended for SVG image support")
    endif()
elseif(CONFIG_GDK_PIXBUF_XLIB)
    #ok
    if (NOT CONFIG_LIBRSVG)
        message(WARNING "CONFIG_LIBRSVG is recommended for SVG image support")
    endif()
elseif(CONFIG_XPM AND CONFIG_LIBPNG)
    #ok
    if (NOT CONFIG_LIBJPEG)
        message(WARNING "LIBJPEG is advisable for backgrounds in icewmbg")
    endif()
    set(CONFIG_LIBRSVG off)
else()
    MESSAGE(FATAL_ERROR ${HINT_IMG_LOADERS})
endif()

if(CONFIG_IMLIB2)
    pkg_check_modules(libimlib2 imlib2)
    if(NOT libimlib2_FOUND)
        message(FATAL_ERROR "IMLIB2 selected but Imlib2 dev files not found."
                ${HINT_IMG_LOADERS})
    endif()
    set(CONFIG_GDK_PIXBUF_XLIB off)
    set(CONFIG_LIBPNG off)
    set(CONFIG_LIBJPEG off)
    LIST(APPEND icewm_img_libs ${libimlib2_LDFLAGS})
endif()

if(CONFIG_GDK_PIXBUF_XLIB)
    pkg_check_modules(pixbuf gdk-pixbuf-xlib-2.0)
    if(NOT pixbuf_FOUND)
        message(FATAL_ERROR "GDX-PIXBUF image loader selected but its dev files were not found."
${HINT_IMG_LOADERS})
    endif()
    set(CONFIG_LIBPNG off)
    set(CONFIG_LIBJPEG off)
    LIST(APPEND icewm_img_libs ${pixbuf_LDFLAGS})
endif()

# this is a) optional, b) loaded through pixbuf anyway
if (CONFIG_LIBRSVG)
    pkg_check_modules(librsvg librsvg-2.0)
    if(NOT librsvg_FOUND)
        message(WARNING
                "SVG image loader selected but librsvg-2.0 dev files not found."
                "SVG support will not be available.")
        set(CONFIG_LIBRSVG off)
    else()
        LIST(APPEND icewm_img_libs ${librsvg_LDFLAGS})
    endif()
endif()

# cursor configuration error check
if(CONFIG_XPM)
    #ok
elseif(CONFIG_IMLIB2)
    #ok
else()
    MESSAGE(FATAL_ERROR ${HINT_CURSORS})
endif()

if(CONFIG_XPM)
    pkg_check_modules(libxpm xpm)
    if(NOT libxpm_FOUND)
        message(FATAL_ERROR
                "XPM image loader selected but libXpm dev files not found."
                ${HINT_IMG_LOADERS})
    endif()
    LIST(APPEND icewm_img_libs ${libxpm_LDFLAGS})
endif()

if(CONFIG_LIBPNG)
    pkg_check_modules(libpng libpng)
    if(NOT libpng_FOUND)
        message(FATAL_ERROR
                "PNG image loader selected but libpng dev files not found."
                ${HINT_IMG_LOADERS})
    endif()
    LIST(APPEND icewm_img_libs ${libpng_LDFLAGS})
endif()

if(CONFIG_LIBJPEG)
    pkg_check_modules(libjpeg libjpeg)
    if(NOT libjpeg_FOUND)
        message(FATAL_ERROR
                "JPEG image loader selected but libjpeg dev files not found."
                "Please install libjpeg-dev (or similar)."
                "Otherwise use -DCONFIG_LIBJPEG=off.")
    endif()
    LIST(APPEND icewm_img_libs ${libjpeg_LDFLAGS})
endif()

IF(CONFIG_SESSION)
    LIST(APPEND sm_LIBS SM)
    LIST(APPEND sm_LIBS ICE)
ENDIF()

option(CONFIG_SHAPE "Define to enable transparent frame	decoration (titlebar borders), requests X shape extension." on)
# TODO: check the symbol: AC_CHECK_LIB([Xext],[XShapeCombineRectangles],
if(CONFIG_SHAPE AND NOT xext_FOUND)
    message(WARNING "Xext library not found, disabling CONFIG_SHAPE")
    set(CONFIG_SHAPE off)
endif()

if(CONFIG_XRANDR)
    pkg_check_modules(xrandr xrandr)
    IF(NOT xrandr_FOUND)
        message(WARNING "Xrandr library not found, disabling CONFIG_XRANDR")
        set(CONFIG_XRANDR off)
    ENDIF()
endif()

option(CONFIG_COREFONTS "Define to enable X11 core fonts" off)
option(CONFIG_XFREETYPE "Define to enable XFT support" on)
if(CONFIG_XFREETYPE)
    pkg_check_modules(xft xft>=2.0)
    IF(NOT xft_FOUND)
        message(WARNING "xft library (>=2.0) not found, disabling CONFIG_XFREETYPE")
        set(CONFIG_XFREETYPE off)
        set(CONFIG_COREFONTS on)
    ELSE()
        set(CONFIG_XFREETYPE_VALUE 2)
    ENDIF()
else()
    set(CONFIG_COREFONTS on)
endif()

set(ICESOUND "ALSA,AO,OSS,ESound" CACHE STRING "List of supported audio subsystems")
string(TOLOWER ${ICESOUND} ICESOUND)
message(STATUS "Checking audio subsystems from ICESOUND: ${ICESOUND}")

#clear cache
set(ENABLE_ALSA off)
set(ENABLE_AO off)
set(ENABLE_OSS off)
set(audio_libs )
set(audio_flags )
# Triggers some cmake bug, use copy-pasta for now
#macro(_addsnd varname flagname)
#        set("${FLAGNAME}" "${${varname}_FOUND}")
#        if("${${varname}_FOUND}" EQUAL 1)
#                list(APPEND audio_libs "${${varname}_LDFLAGS}" "${${varname}_LIBS}")
#                list(APPEND audio_flags "${${varname}_CFLAGS}")
#        endif()
#endmacro()

pkg_check_modules(sndfile sndfile)
if(sndfile_FOUND)
    if(sndfile_FOUND)
        list(APPEND audio_flags "${sndfile_CFLAGS}")
        list(APPEND audio_libs ${sndfile_LDFLAGS})
        list(APPEND audio_libs ${sndfile_LIBS})
    endif()
    if("${ICESOUND}" MATCHES "alsa")
        pkg_check_modules(alsa alsa)
        set(ENABLE_ALSA "${alsa_FOUND}")
        if(alsa_FOUND)
            list(APPEND audio_flags "${alsa_CFLAGS}")
            list(APPEND audio_libs ${alsa_LDFLAGS})
            list(APPEND audio_libs ${alsa_LIBS})
        endif()
    endif()
    if("${ICESOUND}" MATCHES "ao")
        pkg_check_modules(ao ao)
        set(ENABLE_AO "${ao_FOUND}")
        if(ao_FOUND)
            list(APPEND audio_flags "${ao_CFLAGS}")
            list(APPEND audio_libs ${ao_LDFLAGS})
            list(APPEND audio_libs ${ao_LIBS})
        endif()
    endif()

=== debian/changelog ===
icewm (2.9.2-1.0antix1) unstable; urgency=medium

  * latest 2.9.2 upsteam
  * antiX build

 -- anticapitalista <antix@operamail.com>  Wed, 08 Dec 2021 11:36:15 +0200

## icewm 2.9.3

=== debian/changelog ===
icewm (2.9.3-1.0antix1) unstable; urgency=medium

  * upstream release
  * antiX build 

 -- anticapitalista <antix@operamail.com>  Mon, 20 Dec 2021 13:47:39 +0200

## icewm 2.9.4

=== debian/changelog ===
icewm (2.9.4-1.0antix1) unstable; urgency=medium

  * upstream release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Fri, 31 Dec 2021 12:33:41 +0200

## icewm 2.9.5

=== debian/changelog ===
icewm (2.9.5-1.0antix1) unstable; urgency=medium

  * upstream release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Thu, 20 Jan 2022 12:13:23 +0200

## icewm 2.9.6

=== po/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
PROJECT(ICEWM CXX)

# yes, FindGettext.cmake exists but it's not really handy :-(
# XXX: document -DEXTRA_MSGMERGE=--verbose -DEXTRA_MSGFMT=--verbose

SET(EXTRA_MSGMERGE "--quiet")

find_program(gettext gettext)
find_program(xgettext xgettext)
find_program(msgmerge msgmerge)
find_program(msgfmt msgfmt)

set(COPYRIGHT_HOLDER "Marko Macek <Marko.Macek@gmx.net>")
set(BUG_ADDRESS "https://github.com/bbidulock/icewm/issues")

if(gettext AND xgettext AND msgmerge AND msgfmt)
	file (STRINGS "POTFILES.in" SRCS)
	# grrr, for make dependency the path needs to match the perspective from the po/ directory.
	# FIXME, how to simplify? Use abs.path for now
	foreach(_src ${SRCS})
		LIST(APPEND SRCSABSOLUTE "${CMAKE_SOURCE_DIR}/${_src}")
	endforeach()
	FILE(GLOB POS "${CMAKE_CURRENT_SOURCE_DIR}/*.po")
	foreach(_src ${POS})
		get_filename_component(_src "${_src}" NAME_WE)
		LIST(APPEND LANGUAGES ${_src})
	endforeach()

	SET(XGETTEXT_CMD xgettext --from-code=UTF-8 -language=CXX --add-comments=TRANSLATORS: --keyword=_ --keyword=N_ -s --package-name=${PACKAGE} --copyright-holder="${COPYRIGHT_HOLDER}"  --package-version="${VERSION}" --msgid-bugs-address="${BUG_ADDRESS}" )
	SET(_potFile "${CMAKE_CURRENT_SOURCE_DIR}/${PACKAGE}.pot")

	# XXX: it "escapes" spaces in arguments no matter how they are quoted. Find a workaround!
	ADD_CUSTOM_COMMAND(OUTPUT stamp-potfile
		COMMAND ${XGETTEXT_CMD} -o "${_potFile}" ${SRCS}
		DEPENDS ${SRCSABSOLUTE}
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		COMMENT "Extracting translatable messages to ${_potFile} -- may require config restart!")
	ADD_CUSTOM_TARGET(update_pot DEPENDS stamp-potfile)

  if(EXISTS ${_potFile})

	if(SKIP_TRANSLATIONS)
		ADD_CUSTOM_TARGET(translations)
	else()
		ADD_CUSTOM_TARGET(translations ALL)
	endif()

	foreach(_lang ${LANGUAGES})
		SET(_tempPO "${CMAKE_CURRENT_BINARY_DIR}/${_lang}.po")
		ADD_CUSTOM_COMMAND(OUTPUT ${_tempPO}
			COMMAND msgmerge -o ${_tempPO} ${EXTRA_MSGMERGE} -s ${CMAKE_CURRENT_SOURCE_DIR}/${_lang}.po ${_potFile}
			WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
			COMMENT "Updated: ${_tempPO}")
		ADD_CUSTOM_TARGET(generate-${_lang}.po DEPENDS ${_tempPO})

		SET(_tempMO "${CMAKE_CURRENT_BINARY_DIR}/${_lang}.gmo")
		ADD_CUSTOM_COMMAND(OUTPUT ${_tempMO}
			COMMAND msgfmt -o ${_tempMO} ${EXTRA_MSGFMT} ${_tempPO}
			DEPENDS ${_tempPO}
			WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
		#COMMENT "Compiled: ${_tempMO}")
		ADD_CUSTOM_TARGET(generate-${_lang}.gmo DEPENDS ${_tempMO})
		install(FILES ${_tempMO} DESTINATION "${LOCDIR}/${_lang}/LC_MESSAGES/" RENAME "${PACKAGE}.mo" OPTIONAL)
		add_dependencies(translations generate-${_lang}.gmo)
	endforeach()

  endif()

endif()

=== debian/changelog ===
icewm (2.9.6-1) unstable; urgency=medium

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Wed, 23 Feb 2022 20:37:31 +0100

icewm (2.9.5-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Fri, 21 Jan 2022 16:59:01 +0100

icewm (2.9.4-1) unstable; urgency=low

  * New upstream release
    + also includes a minor fix for strage EDID data

 -- Eduard Bloch <blade@debian.org>  Tue, 04 Jan 2022 22:04:08 +0100

icewm (2.9.3-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Wed, 22 Dec 2021 11:09:23 +0100

icewm (2.9.2-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Wed, 08 Dec 2021 10:21:04 +0100

icewm (2.9.1-1) unstable; urgency=medium

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Thu, 02 Dec 2021 20:09:51 +0100

icewm (2.9.0-1) unstable; urgency=low

  * New upstream release
  * Dropping old preference for DejaVu font with size 11 in Debian builds

 -- Eduard Bloch <blade@debian.org>  Wed, 24 Nov 2021 21:12:07 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: x11
 Priority: optional
 Maintainer: Eduard Bloch <blade@debian.org>
-Build-Depends: debhelper (>= 9), libxrender-dev, gettext, libxft-dev (>> 2.1.1) | libxft2-dev, libsndfile1-dev, libao-dev, libsm-dev, libx11-dev, libxext-dev, libxinerama-dev, libxrandr-dev, x11proto-core-dev | x-dev, dpkg-dev (>= 1.16.1~), cmake, asciidoctor, libglib2.0-dev, libfribidi-dev, librsvg2-dev, libxcomposite-dev, libxdamage-dev, pandoc, libimlib2-dev
+Build-Depends: debhelper (>= 10), libxrender-dev, gettext, libxft-dev (>> 2.1.1) | libxft2-dev, libsndfile1-dev, libao-dev, libsm-dev, libx11-dev, libxext-dev, libxinerama-dev, libxrandr-dev, x11proto-core-dev | x-dev, dpkg-dev (>= 1.16.1~), cmake, asciidoctor, libglib2.0-dev, libfribidi-dev, librsvg2-dev, libxcomposite-dev, libxdamage-dev, pandoc, libimlib2-dev
 Build-Conflicts: libttf-dev, libesd0-dev
 Standards-Version: 4.5.0
 Vcs-Git: https://github.com/Code7R/icewm.git

## icewm 2.9.7

=== debian/changelog ===
icewm (2.9.7-1.0antix1) unstable; urgency=medium

  * upstream release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Mon, 02 May 2022 11:41:46 +0300

icewm (2.9.6-1.0antix1) unstable; urgency=medium

  * upstream release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Thu, 24 Feb 2022 12:08:17 +0200

## icewm 2.9.8

=== debian/changelog ===
icewm (2.9.8-1.0antix1) unstable; urgency=medium

  * upstream release
  * antiX build 

 -- anticapitalista <antix@operamail.com>  Tue, 19 Jul 2022 20:27:26 +0300

## icewm 2.9.9

=== debian/changelog ===
icewm (2.9.9-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Fri, 05 Aug 2022 21:58:29 +0200

icewm (2.9.8-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Thu, 21 Jul 2022 07:22:32 +0200

icewm (2.9.7-1) unstable; urgency=medium

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Wed, 04 May 2022 22:02:19 +0200

## icewm 3.0.0

=== doc/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
PROJECT(ICEWM CXX)

#
# The list of files which need to be converted to HTML.
#
set(MARK_FILES icewm.md)
set(ADOC_FILES icewm.adoc)

#
# The destination directory for HTML pages.
#
if(NOT HTMLDIR)
    if(ICEHELPIDX)
        get_filename_component(HTMLDIR "${ICEHELPIDX}" PATH)
    else()
        set(HTMLDIR "${DOCDIR}")
    endif()
endif()

#
# Detect input processor.
#
if(NOT MARKDOWN AND NOT ASCIIDOC)
    find_program(MARKDOWN NAMES markdown markdown_py discount-markdown Markdown.pl)
    if (NOT MARKDOWN)
        find_program(ASCIIDOC NAMES asciidoctor asciidoc)
    endif()
endif()

#
# Convert Markdown pages to HTML.
#
if(MARKDOWN)
    set(HTML_OUTPUT_FILES)
    foreach(mark ${MARK_FILES})
        string(REGEX REPLACE \\.md$ .html htm ${mark})
        set(txt "${CMAKE_SOURCE_DIR}/doc/${mark}")
        set(out "${CMAKE_BINARY_DIR}/${htm}")
        ADD_CUSTOM_COMMAND(OUTPUT "${out}"
            COMMAND ${MARKDOWN} "${txt}" > "${out}"
            DEPENDS "${txt}"
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            )
        list(APPEND HTML_OUTPUT_FILES "${out}")
    endforeach()
    ADD_CUSTOM_TARGET(build_html_docs ALL DEPENDS ${HTML_OUTPUT_FILES})

#
# Convert AsciiDoc pages to HTML.
#
elseif(ASCIIDOC)
    if(NOT ASCIIDOC_BACKEND)
        if(ASCIIDOC MATCHES asciidoctor$)
            set(ASCIIDOC_BACKEND --backend=html5)
        elseif(ASCIIDOC MATCHES asciidoc$)
            set(ASCIIDOC_BACKEND --backend=html4)
        endif()
    endif()

    set(HTML_OUTPUT_FILES)
    foreach(adoc ${ADOC_FILES})
        string(REGEX REPLACE \\.adoc$ .html htm ${adoc})
        set(txt "${CMAKE_SOURCE_DIR}/doc/${adoc}")
        set(out "${CMAKE_BINARY_DIR}/${htm}")
        ADD_CUSTOM_COMMAND(OUTPUT "${out}"
            COMMAND ${ASCIIDOC} ${ASCIIDOC_BACKEND} -o "${out}" "${txt}"
            DEPENDS "${txt}"
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            )
        list(APPEND HTML_OUTPUT_FILES "${out}")
    endforeach()
    ADD_CUSTOM_TARGET(build_html_docs ALL DEPENDS ${HTML_OUTPUT_FILES})

else()
    message(WARNING "markdown and asciidoctor not found.\n"
            "NOT regenerating HTML documentation.\n"
            "To rebuild install markdown or asciidoctor.")
    FILE(GLOB HTML_OUTPUT_FILES *.html)
endif()

#
# Install HTML pages.
#
foreach(html ${HTML_OUTPUT_FILES})
    install(FILES "${html}" DESTINATION "${HTMLDIR}")
endforeach()
message(STATUS "HTMLDIR => ${HTMLDIR}")

=== debian/changelog ===
icewm (3.0.0-1.0antix1) unstable; urgency=medium

  * upstream release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Mon, 03 Oct 2022 18:39:18 +0300

## icewm 3.1.0

=== lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
PROJECT(ICEWM CXX)

#
# Which themes to install in alphabetical order
#
set(themesList CrystalBlue Helix Infadel2 NanoBlue
    default icedesert metal2 motif win95)

foreach(_src keys menu programs toolbar winoptions IceWM.jpg)
    set(_pre "${CMAKE_CURRENT_SOURCE_DIR}/${_src}.in")
    if(EXISTS "${_pre}")
        CONFIGURE_FILE("${_pre}" "${CMAKE_CURRENT_BINARY_DIR}/${_src}")
        install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${_src}"
                DESTINATION "${LIBDIR}")
    else()
        install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/${_src}"
                DESTINATION "${LIBDIR}")
    endif()
endforeach()

install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/icewm.desktop" DESTINATION "${DATADIR}/xsessions/")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/icewm-session.desktop" DESTINATION "${DATADIR}/xsessions/")

install(DIRECTORY mailbox taskbar icons ledclock
        DESTINATION "${LIBDIR}"
        FILES_MATCHING PATTERN "*"
        PATTERN "*.in" EXCLUDE)

foreach(theme ${themesList})
    install(DIRECTORY "themes/${theme}"
            DESTINATION "${LIBDIR}/themes")
endforeach()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,11 @@
-cmake_minimum_required(VERSION 3.2)
+
+# to use target_link_options
+cmake_minimum_required(VERSION 3.13)
 
 PROJECT(ICEWM CXX)
 
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_STANDARD_REQUIRED on)
-# TODO: drop this warning around xmas 2020 and raise cmake_minimum_required instead; Debian Jessie EOLs around 2020-06
-if(${CMAKE_VERSION} VERSION_LESS "3.1")
-    message(WARNING "!! Ancient cmake version detected, please pass flags for C++11 enabling manually through CXXFLAGS environment variable or override CMAKE_CXX_FLAGS")
-endif()
 
 INCLUDE(CheckIncludeFiles)
 INCLUDE(CheckLibraryExists)
@@ -22,7 +20,31 @@
 SET(CXXFLAGS_COMMON -pthread -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE -DHAVE_CONFIG_H -include "${CMAKE_BINARY_DIR}/config.h")
 include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})
 
-set(icewm_libs "")
+unset(icewm_libs)
+unset(Intl_INCLUDE_DIRS)
+
+macro(concat_dedup _result_var)
+    set(${_result_var} ${ARGN})
+    list(REMOVE_DUPLICATES ${_result_var})
+endmacro()
+
+option(AUTO_INC_HEADERS "Guess related headers and include in the build config (developer comfort feature)" off)
+macro(do_auto_inc_headers _in_out_var)
+    if(AUTO_INC_HEADERS)
+        set(auto_inc_headers_tmp)
+        foreach(src ${${_in_out_var}})
+            list(APPEND auto_inc_headers_tmp ${src})
+            cmake_path(REPLACE_EXTENSION src .h OUTPUT_VARIABLE h_cand)
+            message("Looking for ${h_cand}")
+            if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${h_cand}")
+                list(APPEND auto_inc_headers_tmp "${h_cand}")
+            endif()
+        endforeach()
+        list(REMOVE_DUPLICATES auto_inc_headers_tmp)
+        set(${_in_out_var} ${auto_inc_headers_tmp})
+    endif()
+endmacro()
+
 # optimize for release if not defined explicitly, can be overriden with CMAKE_BUILD_TYPE "None"
 if("${CMAKE_BUILD_TYPE}" STREQUAL "" AND ("" STREQUAL "${CMAKE_CXX_FLAGS}"))
     SET(CMAKE_BUILD_TYPE Release)
@@ -86,24 +108,28 @@
 ENDIF()
 SET(XTERMCMD xterm CACHE STRING "Default terminal emulator for X11")
 
-# TODO: find some common helper to handle that variables
 if(ENABLE_NLS OR CONFIG_I18N)
     find_library(CONFIG_LIBICONV iconv)
     if(CONFIG_LIBICONV)
         LIST(APPEND nls_LIBS iconv)
     endif()
-    INCLUDE(FindIntl)
+# XXX: once cmake 3.20 became standard, replace this block with dependency on
+# Intl::Intl interface target.
+    include(FindIntl)
     if(Intl_FOUND)
-        LIST(APPEND nls_LIBS ${Intl_LIBRARIES})
-        if(${Intl_INCLUDE_DIRS})
-            LIST(APPEND nls_CFLAGS -I${Intl_INCLUDE_DIRS})
-        endif()
+        list(APPEND nls_LIBS ${Intl_LIBRARIES})
     endif()
 endif()
 
 if(ENABLE_LTO AND ${CMAKE_HOST_SYSTEM_NAME} MATCHES "Linux")
-    list(APPEND CXXFLAGS_COMMON -flto)
-    list(APPEND EXTRA_LIBS -flto)
+    # https://stackoverflow.com/questions/72218980/gcc-v12-1-warning-about-serial-compilation
+    check_cxx_compiler_flag(-flto=auto USE_LTOAUTO)
+    if(USE_LTOAUTO)
+        list(APPEND CXXFLAGS_COMMON -flto=auto)
+    else()
+        list(APPEND CXXFLAGS_COMMON -flto)
+    endif()
+    list(APPEND EXTRA_LINKER_FLAGS -flto)
 endif()
 
 # the only used ones...
@@ -163,12 +189,12 @@
 if(CONFIG_IMLIB2)
     #ok
     if (NOT CONFIG_LIBRSVG)
-        message(WARNING "CONFIG_LIBRSVG is recommended for SVG image support")
+        message(WARNING "-DCONFIG_LIBRSVG=on is recommended for SVG image support")
     endif()
 elseif(CONFIG_GDK_PIXBUF_XLIB)
     #ok
     if (NOT CONFIG_LIBRSVG)
-        message(WARNING "CONFIG_LIBRSVG is recommended for SVG image support")
+        message(WARNING "-DCONFIG_LIBRSVG=on is recommended for SVG image support")
     endif()
 elseif(CONFIG_XPM AND CONFIG_LIBPNG)
     #ok
@@ -293,22 +319,12 @@
 
 set(ICESOUND "ALSA,AO,OSS,ESound" CACHE STRING "List of supported audio subsystems")
 string(TOLOWER ${ICESOUND} ICESOUND)
-message(STATUS "Checking audio subsystems from ICESOUND: ${ICESOUND}")
-
-#clear cache
+message(STATUS "Checking audio subsystems for ICESOUND: ${ICESOUND}")
+
+# clear cache, just in case that user has set them as command line options
 set(ENABLE_ALSA off)
 set(ENABLE_AO off)
 set(ENABLE_OSS off)
-set(audio_libs )
-set(audio_flags )
-# Triggers some cmake bug, use copy-pasta for now
-#macro(_addsnd varname flagname)
-#        set("${FLAGNAME}" "${${varname}_FOUND}")
-#        if("${${varname}_FOUND}" EQUAL 1)
-#                list(APPEND audio_libs "${${varname}_LDFLAGS}" "${${varname}_LIBS}")
-#                list(APPEND audio_flags "${${varname}_CFLAGS}")
-#        endif()
-#endmacro()
 
 pkg_check_modules(sndfile sndfile)
 if(sndfile_FOUND)
@@ -322,16 +338,3 @@
         set(ENABLE_ALSA "${alsa_FOUND}")
         if(alsa_FOUND)
             list(APPEND audio_flags "${alsa_CFLAGS}")
-            list(APPEND audio_libs ${alsa_LDFLAGS})
-            list(APPEND audio_libs ${alsa_LIBS})
-        endif()
-    endif()
-    if("${ICESOUND}" MATCHES "ao")
-        pkg_check_modules(ao ao)
-        set(ENABLE_AO "${ao_FOUND}")
-        if(ao_FOUND)
-            list(APPEND audio_flags "${ao_CFLAGS}")
-            list(APPEND audio_libs ${ao_LDFLAGS})
-            list(APPEND audio_libs ${ao_LIBS})
-        endif()
-    endif()

=== debian/changelog ===
icewm (3.1.0-1.0antix1) unstable; urgency=medium

  * upstream bugfix release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Mon, 24 Oct 2022 13:15:08 +0300

icewm (3.0.1-1.0antix2) unstable; urgency=medium

  * fix zzzFM/SpaceFM conky3
  

 -- anticapitalista <antix@operamail.com>  Thu, 13 Oct 2022 01:33:45 +0300

icewm (3.0.1-1.0antix1) unstable; urgency=medium

  * upstream bugfix release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Thu, 06 Oct 2022 14:50:25 +0300

## icewm 3.2.0

=== debian/changelog ===
icewm (3.2.0-1.0antix1) unstable; urgency=medium

  * upstream 3.2 release with many enhancements
  * antiX build

 -- anticapitalista <antix@operamail.com>  Thu, 03 Nov 2022 15:29:43 +0200

## icewm 3.2.2

=== debian/changelog ===
icewm (3.2.2-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Thu, 01 Dec 2022 22:03:54 +0100

icewm (3.1.0-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Thu, 27 Oct 2022 20:40:05 +0200

icewm (3.0.1-1) unstable; urgency=low

  * New upstream release

 -- Eduard Bloch <blade@debian.org>  Thu, 06 Oct 2022 18:57:05 +0200

## icewm 3.2.3

=== debian/changelog ===
icewm (3.2.3-1.0antix1) unstable; urgency=medium

  * upstream bugfix release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Mon, 05 Dec 2022 23:10:48 +0200

icewm (3.2.2-1.0antix1) unstable; urgency=medium

  * upstream bugfix release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Tue, 15 Nov 2022 00:33:17 +0200

icewm (3.2.1-1.0antix1) unstable; urgency=medium

  * upstream bugfix release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Wed, 09 Nov 2022 15:21:46 +0200

## icewm 3.3.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -45,6 +45,21 @@
     endif()
 endmacro()
 
+macro(pkg_check_or_fail _prefix _what)
+    clear_pkg_config(${_prefix})
+    pkg_check_modules(${_prefix} ${_what})
+    if(NOT ${_prefix}_FOUND)
+        message(FATAL_ERROR ${ARGN})
+    endif()
+endmacro()
+
+# drop remainings variables of pkg_config's work from the current scope
+macro(clear_pkg_config _prefix)
+    foreach(_i "_LIBRARIES" "_LINK_LIBRARIES" "_LIBRARY_DIRS" "_LDFLAGS" "_LDFLAGS_OTHER" "_INCLUDE_DIRS" "_CFLAGS" "_CFLAGS_OTHER")
+        unset("${_prefix}${_i}")
+    endforeach()
+endmacro()
+
 # optimize for release if not defined explicitly, can be overriden with CMAKE_BUILD_TYPE "None"
 if("${CMAKE_BUILD_TYPE}" STREQUAL "" AND ("" STREQUAL "${CMAKE_CXX_FLAGS}"))
     SET(CMAKE_BUILD_TYPE Release)
@@ -76,11 +91,6 @@
         list(APPEND CXXFLAGS_COMMON -Wimplicit-fallthrough)
     endif()
 endif()
-
-#CHECK_CXX_COMPILER_FLAG(-Wl,-fuse-ld=gold CXX_LINKER_GOLD)
-#if(CXX_LINKER_GOLD)
-#    list(APPEND icewm_libs -Wl,-fuse-ld=gold)
-#endif()
 
 option(CONFIG_IMLIB2 "Imlib2 image loader" on)
 option(CONFIG_LIBPNG "PNGLIB image loader" off)
@@ -129,7 +139,6 @@
     else()
         list(APPEND CXXFLAGS_COMMON -flto)
     endif()
-    list(APPEND EXTRA_LINKER_FLAGS -flto)
 endif()
 
 # the only used ones...
@@ -207,11 +216,7 @@
 endif()
 
 if(CONFIG_IMLIB2)
-    pkg_check_modules(libimlib2 imlib2)
-    if(NOT libimlib2_FOUND)
-        message(FATAL_ERROR "IMLIB2 selected but Imlib2 dev files not found."
-                ${HINT_IMG_LOADERS})
-    endif()
+    pkg_check_or_fail(libimlib2 imlib2 "IMLIB2 selected but Imlib2 dev files not found.")
     set(CONFIG_GDK_PIXBUF_XLIB off)
     set(CONFIG_LIBPNG off)
     set(CONFIG_LIBJPEG off)
@@ -219,11 +224,9 @@
 endif()
 
 if(CONFIG_GDK_PIXBUF_XLIB)
-    pkg_check_modules(pixbuf gdk-pixbuf-xlib-2.0)
-    if(NOT pixbuf_FOUND)
-        message(FATAL_ERROR "GDX-PIXBUF image loader selected but its dev files were not found."
-${HINT_IMG_LOADERS})
-    endif()
+    pkg_check_or_fail(pixbuf gdk-pixbuf-xlib-2.0
+        "GDX-PIXBUF image loader selected but its dev files were not found."
+        ${HINT_IMG_LOADERS})
     set(CONFIG_LIBPNG off)
     set(CONFIG_LIBJPEG off)
     LIST(APPEND icewm_img_libs ${pixbuf_LDFLAGS})
@@ -252,39 +255,26 @@
 endif()
 
 if(CONFIG_XPM)
-    pkg_check_modules(libxpm xpm)
-    if(NOT libxpm_FOUND)
-        message(FATAL_ERROR
-                "XPM image loader selected but libXpm dev files not found."
-                ${HINT_IMG_LOADERS})
-    endif()
+    pkg_check_or_fail(libxpm xpm "XPM image loader selected but libXpm dev files not found."
+        ${HINT_IMG_LOADERS})
     LIST(APPEND icewm_img_libs ${libxpm_LDFLAGS})
 endif()
 
 if(CONFIG_LIBPNG)
-    pkg_check_modules(libpng libpng)
-    if(NOT libpng_FOUND)
-        message(FATAL_ERROR
-                "PNG image loader selected but libpng dev files not found."
-                ${HINT_IMG_LOADERS})
-    endif()
+    pkg_check_or_fail(libpng libpng "PNG image loader selected but libpng dev files not found."
+        ${HINT_IMG_LOADERS})
     LIST(APPEND icewm_img_libs ${libpng_LDFLAGS})
 endif()
 
 if(CONFIG_LIBJPEG)
-    pkg_check_modules(libjpeg libjpeg)
-    if(NOT libjpeg_FOUND)
-        message(FATAL_ERROR
-                "JPEG image loader selected but libjpeg dev files not found."
-                "Please install libjpeg-dev (or similar)."
-                "Otherwise use -DCONFIG_LIBJPEG=off.")
-    endif()
+    pkg_check_or_fail(libjpeg libjpeg "JPEG image loader selected but libjpeg dev files not found."
+        "Please install libjpeg-dev (or similar)."
+        "Otherwise use -DCONFIG_LIBJPEG=off.")
     LIST(APPEND icewm_img_libs ${libjpeg_LDFLAGS})
 endif()
 
 IF(CONFIG_SESSION)
-    LIST(APPEND sm_LIBS SM)
-    LIST(APPEND sm_LIBS ICE)
+    LIST(APPEND sm_LIBS SM ICE)
 ENDIF()
 
 option(CONFIG_SHAPE "Define to enable transparent frame	decoration (titlebar borders), requests X shape extension." on)
@@ -329,12 +319,16 @@
 pkg_check_modules(sndfile sndfile)
 if(sndfile_FOUND)
     if(sndfile_FOUND)
-        list(APPEND audio_flags "${sndfile_CFLAGS}")
-        list(APPEND audio_libs ${sndfile_LDFLAGS})
-        list(APPEND audio_libs ${sndfile_LIBS})
+        list(APPEND audio_flags ${sndfile_CFLAGS})
+        list(APPEND audio_libs ${sndfile_LDFLAGS} ${sndfile_LIBS})
     endif()
     if("${ICESOUND}" MATCHES "alsa")
         pkg_check_modules(alsa alsa)
-        set(ENABLE_ALSA "${alsa_FOUND}")
+        set(ENABLE_ALSA ${alsa_FOUND})
         if(alsa_FOUND)
-            list(APPEND audio_flags "${alsa_CFLAGS}")
+            list(APPEND audio_flags ${alsa_CFLAGS})
+            list(APPEND audio_libs ${alsa_LDFLAGS} ${alsa_LIBS})
+        endif()
+    endif()
+    if("${ICESOUND}" MATCHES "ao")
+        pkg_check_modules(ao ao)

=== debian/changelog ===
icewm (3.3.0-1.0antix1) unstable; urgency=medium

  * upstream bugfix and enhancement release
  * antiX build

 -- anticapitalista <antix@operamail.com>  Wed, 21 Dec 2022 14:04:23 +0200
